/*
 * encoder.c
 *
 * Created: 11.09.2013 11:44:08
 *  Author: Orion
 */ 

#include "encoder.h"

/************************************************************************/
/* Initialization                                                       */
/************************************************************************/

inline void EncoderInit(void)
{
    // Init pull-up resistors
    ENC_PORT |= 1<<ENC_PINA
             |  1<<ENC_PINB
             |  1<<ENC_KNOB;
    // Init interrupts
    ENC_INT_MASK |= 1<<ENC_INT_KNOB
                 |  1<<ENC_INT_PINA;
    ENC_INT_REG  |= 1<<ENC_INT_ENBL;
 }

void EncoderCapture()
{
    static uint8_t _prev;
    uint8_t _curr = ENC_PIN & (1<<ENC_PINA | 1<<ENC_PINB | 1<<ENC_KNOB);
    
    //    
    if (~(_prev & 1<<ENC_KNOB) & (_curr & 1<<ENC_KNOB))
        enc_state.press = 1;
    if (~(_curr & 1<<ENC_KNOB) & (_prev & 1<<ENC_KNOB))
        enc_state.rel   = 1;

    switch (_curr & (1<<ENC_PINA | 1<<ENC_PINB))          //       
    {
        //         
        case (1<<ENC_PINB):
            enc_state.inc = (enc_state.delay)? 10 : 1;
            //enc_state.delay = 1;
            enc_state.spin  = 1;
            //SoftTimerSet(&SoftTimer.speed);
        break;
        case (1<<ENC_PINA | 1<<ENC_PINB):
            enc_state.inc = (enc_state.delay)? -10: -1;
            //enc_state.delay = 1;
            enc_state.spin  = 1;
            //SoftTimerSet(&SoftTimer.speed);
        break;
    }
    _prev = _curr;
    SBI(ENC_INT_REG, ENC_INT_ENBL);

}

//  

ISR(ENC_INT)
{
    CBI(ENC_INT_REG, ENC_INT_ENBL);           //        
    //SoftTimerSet(ENC_RD, ENC_RD_DELAY);     //        
    SetTimerTask(EncoderCapture, ENC_RD_DELAY);
}
