/*
 * rtos.h
 *
 * Created: 26.09.2013 10:06:45
 *  Author: Orion
 */ 


#ifndef RTOS_H_
#define RTOS_H_

#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "mylib.h"

/************************************************************************/
/* RTOS Config                                                          */
/************************************************************************/

#define RTOS_ISR        TIMER0_OVF_vect
#define TSK_QUE_SIZE    5
#define MAIN_TMR_SIZE   5

/************************************************************************/
/* RTOS Management                                                      */
/************************************************************************/

uint8_t add_tsk_idx, get_tsk_idx,
        add_tmr_idx, get_tmr_idx;

typedef void (*tsk_ptr_t) (void);    //    
tsk_ptr_t TaskQueue[TSK_QUE_SIZE];   //   

typedef struct
{
    tsk_ptr_t goToTask;     //   
    uint16_t delay;         //    
} main_tmr_t;

main_tmr_t MainTimer[MAIN_TMR_SIZE]; //   

typedef main_tmr_t *main_tmr_ptr_t;

main_tmr_ptr_t TimerQueue[MAIN_TMR_SIZE]; //    

extern void RunRTOS(void);
extern void InitRTOS(void);
extern void Idle(void);   //  -


extern void AddTask(tsk_ptr_t _task);
extern void SetTimerTask(tsk_ptr_t _task, uint16_t _delay);

extern void TaskMgr(void);
extern void TimerMgr(void);



#endif /* RTOS_H_ */